from abc import ABC,abstractmethod
from calendar import c
import unittest
from weakref import ref

#Interface 
class ICounter (ABC): 
    @abstractmethod
    def count_ED(self,s):
        pass

# Implementierung Klasse 
class Counter (ICounter):
    def count_ED (self,):
        s=s.upper()
        return s.count("D")+s.count("E")

class TestCounter (unittest. TestCase):
   def setUp(self):
       self.c= Counter()

   def test_count_ED_regular (self):
       self.c
       res=c.count_ED ("Decker")
       self.assertEqual(res,3)

   def test_count_ED_empty (self):   
     ergebnis=self.c.count_ED("")    
     self.assertCountEqual(ergebnis,0)

   def test_count_ED_wo (self):
       """testet einen string ohne E und D"""
       ergebnis=self.c.count_ED("Hallo")
       self.assertEqual(ergebnis, 0)  

   def test_count_ED_insensitive(self):    
     """TEstes verschiedene Groß und Kleinschreibungen"""
     ergebnis=self.c.count_ED("Der Esel")
     self.assertEqual(ergebnis, 4)

   def test_count_ED_single_letter(self):
     """Testet Eingaben nur mit einem Buchstaben"""
     ergebnis=self.c.count_ED("D")
     self.assertEqual(ergebnis,1)
     ergebnis=self.c.count_ED("E")
     self.assertEqual(ergebnis,1)  
     ergebnis=self.c.count_ED("d")
     self.assertEqual(ergebnis,1)  
     ergebnis=self.c.count_ED("e")
     self.assertEqual(ergebnis,1)      
     
   
if __name__=="__main__":
    unittest.main()       


