from calculator import Calculator

# Instanz der Calculator-Klasse erstellen
calc = Calculator()

# Funktionen des Taschenrechners verwenden
print("Addition:", calc.add(10, 5))   # → 15
print("Subtraktion:", calc.sub(10, 5)) # → 5


# Fehlerbehandlung testen (Division durch Null)
try:
    print(calc.div(10, 0))  
except ValueError as e:
    print("Fehler:", e)  # → "Division durch 0 ist nicht erlaubt."
